# Configurations

A common pattern in building integrations is validating them across different settings, environments or even customer profiles. For example, you may want to validate an integration using test credentials. In Laminar, this is handled by *configuration stores*.

With configuration stores, users can create different configurations and choose a specific configuration to execute a workflow.

## 1. Creating a configuration

The first step is to create key-value configuration pairs

{% hint style="warning" %}
Configuration keys are case-sensitive.
{% endhint %}

{% @arcade/embed flowId="8TIt4BHaRNQaC0OGcFoz" url="<https://app.arcade.software/share/8TIt4BHaRNQaC0OGcFoz>" %}

## 2. Use configuration in workflow steps

When you need to use configuration variables within your workflow steps definition, use the following format:

```javascript
{{config.<configuration_key>}}
```

**Example:**

```javascript
(data) => {
  let transformed_data = data.step_1.response
  
  return {
    "lam.httpRequest": {
      "method": "POST",
      "url": "{{config.WAREHOUSE_API_URL}}/warehouse/orders",
      "headers": {
        "Content-Type": "application/json"
      },
      "body": transformed_data
    }
  };
}
```

## 3. Execute workflow with specific configuration

In order to execute a workflow with a specific configuration, you need to add the configuration id to the workflow execution url. Refer to the example below:

```bash
# Execute workflow for Customer A
# workflow_execution_url: https://api.laminar.run/workflow/execute/external/<workflow_id>?api_key=<api_key>

curl -X POST '<workflow_execution_url>&configuration_id=<configuration_id>' \
  -H 'Content-Type: application/json' \
  -d '{
    "data": "your workflow input"
  }'
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.laminar.run/building-an-integration/advanced/configurations.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
